#ifndef IO_H
#define IO_H

#include <os9/const.h>

#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2

enum devflags {
	O_READ   = 1 << 0,
	O_WRITE  = 1 << 1,
	O_RDWR   = 1 << 2,
	O_BIND   = 1 << 3,
	O_DIR    = 1 << 4,
	O_STAT   = 1 << 5,
};

struct dirent {
	char d_name[NAMELEN];
};

typedef struct {
	int fd;
	unsigned char buf[DIRLEN];
} DIR;

extern DIR *opendir(char *name);
extern int readdir(DIR *dir, struct dirent *ent);
extern int closedir(DIR *dir);

/* driver functions */
extern int mount(char *srv, char *mnt, char *spec);
extern int create(char *name, int flags);
extern int open(char *name, int flags);
extern int close(int fd);
extern int read(int fd, void *buf, int n);
extern int write(int fd, void *buf, int n);
extern int seek(int fd, long off, int whence);
extern int bind(char *path, char *where);
extern int stat(char *path, void *buf, int n);
extern int fsync(int fd);
extern void sync(void);

#endif /* IO_H */
