CONF     = amd64-linux
TOOL     = gnu
include $(PROJECTDIR)/config/$(CONF).mk
include $(PROJECTDIR)/config/toolchain/$(TOOL).mk

INCDIR    = $(PROJECTDIR)/include
LIBDIR    = $(PROJECTDIR)/lib
BINDIR    = $(PROJECTDIR)/bin
DRVDIR    = $(PROJECTDIR)/drivers
FSDIR     = $(PROJECTDIR)/fs
SRCDIR    = $(PROJECTDIR)/src
SCRIPTDIR = $(PROJECTDIR)/scripts
CONFDIR   = $(PROJECTDIR)/config
INCLUDES  = -I$(INCDIR) -I$(INCDIR)/bits/$(ARCH)/ -I$(INCDIR)/bits/$(SYS)
LIBS      = -lk -lc
ENVIRON   = $(SCRIPTDIR)/env.sh

LIBDEP = $(LIBDIR)/libk.a \
         $(LIBDIR)/libc.a \
         $(LIBDIR)/lib9p.a \

PROJ_CFLAGS = $(MORECFLAGS) \
               $(INCLUDES) \
               $(TOOLCFLAGS) \
               $(SYSCFLAGS) \
               $(CFLAGS)

PROJ_LDFLAGS = $(MORELDFLAGS) \
                -L$(LIBDIR) \
                $(TOOLLDFLAGS) \
                $(SYSLDFLAGS) \
                $(LDFLAGS)

PROJ_ASFLAGS = $(MOREASFLAGS) \
                $(TOOLASFLAGS) \
                $(SYSASFLAGS) \
                $(ASFLAGS)

PROJ_LDLIBS = $(MORELDLIBS) \
               $(LIBS) \
               $(TOOLLDLIBS) \
               $(SYSLDLIBS) \
               $(LDLIBS)

CC = $(CROSS_COMPILE)$(COMP)
AS = $(CROSS_COMPILE)$(ASM)
LD = $(CROSS_COMPILE)$(LINKER)
OC = $(CROSS_COMPILE)$(OBJCOPY)
OD = $(CROSS_COMPILE)$(OBJDUMP)
RL = $(CROSS_COMPILE)$(RANLIB)
AR = $(CROSS_COMPILE)$(ARCHIVE)
HOSTCC=$(COMP)

FORALL= +@set -e ;\
	. $(ENVIRON); \
	pwd=$$PWD; \
	for i in $(DIRS); \
	do \
		cd $$i; \
		$(MAKE) $@; \
		cd $$pwd; \
	done

.SUFFIXES: .map .dump .elf .bin .i

.c.o:
	$(CC) $(PROJ_CFLAGS) -o $@ -c $<

.c:
	$(HOSTCC) $(PROJ_CFLAGS) -o $@  $<

.c.s:
	$(CC) $(PROJ_CFLAGS) -o $@ -S $<

.c.i:
	$(CPP) $(PROJ_CFLAGS) -o $@ $<

.s.o:
	$(AS) $(PROJ_ASFLAGS) -o $@ $<

.elf.bin:
	$(OC) -O binary $< $@

.elf.dump:
	$(OD) -D $< > $@

.o.dump:
	$(OD) -D $< > $@

.elf.map:
	$(LD) -Map=$@ $< -o /dev/null

all:

FORCE:

clean: clean-files

clean-files:
	rm -f *.i *.d *.o *.a $(TARGET)

-include *.d
