#include <errno.h>
#include <string.h>

#include <os9/io.h>

#define NR_DIRS 12


DIR *
opendir(char *name)
{
	int fd;
	DIR *dir;
	static DIR dirs[NR_DIRS];

	for (dir = dirs; dir < &dirs[NR_DIRS] && dir->fd; ++dir)
		;

	if (dir == &dirs[NR_DIRS]) {
		errno = ENOMEM;
		return NULL;
	}

	if ((fd = open(name, O_READ)) < 0)
		return NULL;
	dir->fd = fd;

	/* TODO: check that it is actually a directory */

	return dir;
}
