#include <os9/os9.h>

#include <errno.h>

#include <deserialize.h>
#include <libk.h>

int
p9todir(Dir *dp, unsigned char *buf, int size)
{
	int n, len, type;
	long l, vers;
	unsigned long long path;

	n = 0;
	SHORT(len, buf, n, size);                 /* len */
	SHORT(dp->type, buf, n, size);            /* type */
	LONG(dp->dev, buf, n, size);              /* dev */
	CHAR(type, buf, n, size);                 /* qid.type */
	LONG(vers, buf, n, size);                    /* qid.vers */
	LLONG(path, buf, n, size);                /* qid.path */
	LONG(l, buf, n, size);                    /* mode */
	LONG(l, buf, n, size);                    /* atime */
	LONG(l, buf, n, size);                    /* mtime */
	LLONG(dp->length, buf, n, size);          /* length */
	STRING(NULL, USERLEN, buf, n, size);      /* uid */
	STRING(NULL, USERLEN, buf, n, size);      /* gid */
	STRING(NULL, USERLEN, buf, n, size);      /* muid */
	STRING(dp->name, NAMELEN, buf, n, size);  /* name */
	USED(l);

	if (len != n) {
		errno = EINVAL;
		return -1;
	}
	dp->qid = QID(type, vers, path);

	return n;
}
