#include <os9/os9.h>

#include <string.h>

#ifndef NR_BUFFERS
#define NR_BUFFERS 512
#endif

#ifndef HEAPSIZ
#define HEAPSIZ 4
#endif

union bucket {
	long long ll;
	uintptr_t up;
};

char buffertab[NR_BUFFERS][PAGESIZE];

void *
allocb(int n)
{
	void *addr = NULL;
	static unsigned long npages;
	static mutex_t m;

	lock(&m);
	if (n >= NR_BUFFERS - npages)
		goto end;
	addr= buffertab[npages];
	npages += n;
end:
	unlock(&m);

	return addr;
}

void *
alloc(size_t size)
{
	static int lockalloc;
	size_t n;
	static size_t used;
	static union bucket *heap;
	static mutex_t m;
	union bucket  *bp = NULL;

	lock(&m);
	if (size == 0) {
		lockalloc = 1;
		goto end;
	}

	if (lockalloc)
		goto end;

	if (!heap)
		heap = allocb(HEAPSIZ);

	n = (size-1) / sizeof(union bucket) + 1;
	size = n * sizeof(union bucket);
	if (used > SIZE_MAX - size)
		goto end;
	bp = heap + used;
	used += size;
end:
	unlock(&m);

	return bp;
}
