	.FILE	"arch.s"

	.TEXT
	.GLOBL	interrupt
interrupt:
	CBNZ	X0,1f
	MSR	DAIFSET,#15
	RET
1:
	MSR	DAIFCLR,#15
	RET

	.TEXT
	.GLOBL	barrier
barrier:
	ADR	X1,1f
	LSL	X0,X0,#3
	ADD	X1,X1,X0
	BR	X1

1:
	ISB
	RET

	DSB	SY
	RET

	.TEXT
	.GLOBL	invalltlb
invalltlb:
	TLBI	VMALLE1IS
	DSB	ISH
	ISB
	RET

	.TEXT
	.GLOBL	invtlb
invtlb:
	LSR	X9,X0,#12
	DSB	ISHST
	TLBI	VAE1,X9
	DSB	ISH
	RET

	.TEXT
	.GLOBL	invdcachesetway
invdcachesetway:
	DC	ISW,X0
	RET

	.TEXT
	.GLOBL	invicache
invicache:
	IC	IALLU
	RET

	.TEXT
	.GLOBL	inm8
inm8:
	LDRB	W0,[X0]
	RET

	.TEXT
	.GLOBL	inm16
inm16:
	LDRH	W0,[X0]
	RET

	.TEXT
	.GLOBL	inm32
inm32:
	LDR	W0,[X0]
	RET

	.TEXT
	.GLOBL	outm8
outm8:
	STRB	W0,[X1]
	RET

	.TEXT
	.GLOBL	outm16
outm16:
	STRH	W0,[X1]
	RET

	.TEXT
	.GLOBL	outm32
outm32:
	STR     W0,[X1]
	RET

	.TEXT
	.GLOBL	halt
halt:
	MSR	DAIFSET,#15
	WFE
	B	halt

	.TEXT
	.GLOBL	getctx
getctx:
	STP	X0,X1,[X0,#16*0]
	STP	X2,X3,[X0,#16*1]
	STP	X4,X5,[X0,#16*2]
	STP	X6,X7,[X0,#16*3]
	STP	X8,X9,[X0,#16*4]
	STP	X10,X11,[X0,#16*5]
	STP	X12,X13,[X0,#16*6]
	STP	X14,X15,[X0,#16*7]
	STP	X16,X17,[X0,#16*8]
	STP	X18,X19,[X0,#16*9]
	STP	X20,X21,[X0,#16*10]
	STP	X22,X23,[X0,#16*11]
	STP	X24,X25,[X0,#16*12]
	STP	X26,X27,[X0,#16*13]
	STP	X28,X29,[X0,#16*14]

	MRS	X9,ELR_EL1
	STP	X9,X30,[X0,#16*15]

	MRS	X9,SPSR_EL1
	MRS	X10,ESR_EL1
	STP	X9,X10,[X0,#16*16]

	MOV	X9,SP
	MRS	X10,FAR_EL1
	STP	X9,X10,[X0,#16*17]

	MRS	X9,TTBR0_EL1
	MRS	X10,TTBR1_EL1
	STP	X9,X10,[X0,#16*18]

	RET

	.TEXT
EXCEPTION:
	STP	X0,X1,[SP,#-16*(19-0)]
	STP	X2,X3,[SP,#-16*(19-1)]
	STP	X4,X5,[SP,#-16*(19-2)]
	STP	X6,X7,[SP,#-16*(19-3)]
	STP	X8,X9,[SP,#-16*(19-4)]
	STP	X10,X11,[SP,#-16*(19-5)]
	STP	X12,X13,[SP,#-16*(19-6)]
	STP	X14,X15,[SP,#-16*(19-7)]
	STP	X16,X17,[SP,#-16*(19-8)]
	STP	X18,X19,[SP,#-16*(19-9)]
	STP	X20,X21,[SP,#-16*(19-10)]
	STP	X22,X23,[SP,#-16*(19-11)]
	STP	X24,X25,[SP,#-16*(19-12)]
	STP	X26,X27,[SP,#-16*(19-13)]
	STP	X28,X29,[SP,#-16*(19-14)]

	MRS	X9,ELR_EL1
	STP	X9,X30,[SP,#-16*(19-15)]

	MRS	X9,SPSR_EL1
	MRS	X10,ESR_EL1
	STP	X9,X10,[SP,#-16*(19-16)]

	MOV	X9,SP
	MRS	X10,FAR_EL1
	STP	X9,X10,[SP,#-16*(19-17)]

	MRS	X9,TTBR0_EL1
	MRS	X10,TTBR1_EL1
	STP	X9,X10,[SP,#-16*(19-18)]

	SUB	SP,SP,#16*19
	MOV	X0,SP
	MOV	X29,#0
	BL	trap
	ADR	X0,OUTSYN
	B	panic

	.DATA
OUTSYN:
	.ASCIZ	"out of sync"

	.TEXT
	.GLOBL	swtch
swtch:
	LDP	X9,X10,[X0,#16*18]
	MSR	TTBR0_EL1,X9
	MSR	TTBR1_EL1,X10

	LDP	X9,X10,[X0,#16*17]
	MSR	FAR_EL1,X10
	MOV	SP,X9

	LDP	X9,X10,[X0,#16*16]
	MSR	ESR_EL1,X10
	MSR	SPSR_EL1,X9

	LDP	X9,X30,[X0,#16*15]
	MSR	ELR_EL1,X9

	LDP	X28,X29,[X0,#16*14]
	LDP	X26,X27,[X0,#16*13]
	LDP	X24,X25,[X0,#16*12]
	LDP	X22,X23,[X0,#16*11]
	LDP	X20,X21,[X0,#16*10]
	LDP	X18,X19,[X0,#16*9]
	LDP	X16,X17,[X0,#16*8]
	LDP	X14,X15,[X0,#16*7]
	LDP	X12,X13,[X0,#16*6]
	LDP	X10,X11,[X0,#16*5]
	LDP	X8,X9,[X0,#16*4]
	LDP	X6,X7,[X0,#16*3]
	LDP	X4,X5,[X0,#16*2]
	LDP	X2,X3,[X0,#16*1]
	LDP	X0,X1,[X0,#16*0]

	ERET

	.ALIGN	11
	.GLOBL	vectbl
vectbl:
// CURRENT EL WITH SP0
	B	EXCEPTION	// SYNc
	.ALIGN	7
	B	EXCEPTION	// IRQ
	.ALIGN	7
	B	EXCEPTION	// FIQ
	.ALIGN	7
	B	EXCEPTION	// SERROR

// CURRENT EL WITH SPX
	.ALIGN	7
	B	EXCEPTION	// SYNC
	.ALIGN	7
	B	EXCEPTION	// IRQ
	.ALIGN	7
	B	EXCEPTION	// FIQ
	.ALIGN	7
	B	EXCEPTION	// SERROR

// LOWER EL USING AARCH64
	.ALIGN	7
	B	EXCEPTION	// SYNC
	.ALIGN	7
	B	EXCEPTION	// IRQ
	.ALIGN	7
	B	EXCEPTION	// FIQ
	.ALIGN	7
	B	EXCEPTION	// SERROR

// LOWER EL USING AARCH32
	.ALIGN	7
	B	EXCEPTION	// SYNC
	.ALIGN	7
	B	EXCEPTION	// IRQ
	.ALIGN	7
	B	EXCEPTION	// FIQ
	.ALIGN	7
	B	EXCEPTION	// SERROR
