enum ecvals {
	UNKNOWN   =  0x00,      /* unknown reason */
	TRAPWFI   =  0x01,      /* trapped wfi or wfe */
	TRAPMCR   =  0x03,      /* trapped mcr or mrc (coproc == 1111) */
	TRAPMCRR  =  0x04,      /* trapped mcrr or mrrc (coproc == 1111) */
	TRAPMCR2  =  0x05,      /* trapped mcr or mrc (coproc == 1110) */
	TRAPLDC   =  0x06,      /* trapped LDC or STC */
	TRAPFP    =  0x07,      /* trapped FP/SIMD access */
	TRAPVMRS  =  0x08,      /* trapped VMRS */
	TRAPPTRA  =  0x09,      /* trapped pointer autentication */
	TRAPMCRR2 =  0x0c,      /* trapped mcrr or mrrc (coproc == 1110) */
	ILL       =  0x0e,      /* Illegal execution state */
	SVC32     =  0x11,      /* SVC in AArch32 */
	HVC32     =  0x12,      /* HVC in AArch32 */
	SMC32     =  0x13,      /* SMS in AArch32 */
	SVC       =  0x15,      /* SVC */
	HVC       =  0x16,      /* HVC */
	SMC       =  0x17,      /* SMC */
	TRAPSYS   =  0x18,      /* Trapped MSR, MRS or System instruction */
	TRAP      =  0x1a,      /* trapped ERET, ERETAA, ERETAB */
	EL3EXCP   =  0x1f,      /* implementation defined exception to EL3 */
	IABORTL   =  0x20,      /* Instruction abort from lower level */
	IABORT    =  0x21,      /* Instruction abort from current level */
	PCALIGN   =  0x22,      /* PC aligment fault exception */
	DABORTL   =  0x24,      /* Data abort from lower level */
	DABORT    =  0x25,      /* Data abort from current level */
	SPALIGN   =  0x26,      /* SP aligment fault exception */
	FPE32     =  0x28,      /* Floating-point exception in AArch32 */
	FPE       =  0x2c,      /* Floating-point exception in AArch64 */
	SOFTRES   =  0x2d,	/* Software defined fault syndrome */
	SERROR    =  0x2f,      /* Serror interrupt */
	BREAKL    =  0x30,      /* Breakpoint exception from lower level */
	BREAK     =  0x31,      /* Breakpoint exception from current level */
	STEPL     =  0x32,      /* Software step from lower level */
	STEP      =  0x33,      /* Software step from current level */
	WATCHL    =  0x34,      /* Watchpoint from lower level */
	WATCH     =  0x35,      /* Watchpoint from current level */
	BKPT      =  0x38,      /* BKPT instruction in AArch32 */
	VECTOR    =  0x3a,      /* Vector catch exception in AArch32 */
	TRAPL     =  0x3b,      /* Trap from lower level */
	BRK       =  0x3c,      /* BRK instruction in AArch64 */
	NR_EC_VALS
};

extern const char *const ecstr[];
