#include <os9/os9.h>

#include <string.h>

#include "arch.h"

static uint32_t *early = (uint32_t *) 0x1C090000;


Mach mach = {
	.phystack = 0x80080000,
	.phytext = 0x80000000,
	.kzero = 0xFFFFFF0000000000 - 0x80000000,
};

void
imach(void)
{
	Map *textp, *datap, *stackp, *pagep;
	static Map maps[5];
	extern char text[], etext[], end[];

	mach.maps = maps;
	textp = &maps[0];
	datap = &maps[1];
	stackp = &maps[2];
	pagep = &maps[3];

	textp->name = "text";
	textp->pa = mach.phytext;
	textp->va = mach.phytext + mach.kzero;
	textp->siz = etext - text;
	textp->perm = MR | MX;

	datap->name = "data";
	datap->pa = textp->pa +textp->siz;
	datap->va = datap->pa + mach.kzero;
	datap->siz = end - etext;
	datap->perm = MR | MW;

	stackp->name = "stack";
	stackp->pa = mach.phystack - 4*KiB;
	stackp->va = datap->va + datap->siz + 4*KiB;
	stackp->siz = 4*KiB;
	stackp->perm = MR | MW;

	pagep->name = "ptable";
	pagep->pa = mach.phystack;
	pagep->va = 0xFFFFFF0000080000;
	pagep->siz = PAGESIZE * 20;
	pagep->perm = MR | MW;
}

int
getch(void)
{
	char ch;

	if (!console)
		panic("getch out of sync");
	devread(console, &ch, 1);
	return ch;
}

void
putch(int c)
{
	char ch;

	if (console) {
		ch = c;
		devwrite(console, &ch, 1);
	} else {
		if (c == '\n')
			putch('\r');
		while (inm32(early+ 6) & 1<<5)
			;
		outm32(c, early);
	}

	barrier(DATA);
	barrier(CODE);
}
