#include <stddef.h>

#define NR_FILES  20
#define NODEV     255
#define CHDIR     0x80
#define CHFILE    0x00

#define SYNCDEV   0
#define SYNCALL   1

typedef struct dev Dev;
typedef struct dirtab Dirtab;
typedef int Devgen(Chan *, Dirtab *, int, int, Dir *);
typedef struct attr Attr;

struct dirtab {
	char name[NAMELEN];
	Qid qid;
	long length;
	unsigned char perm;
	void *data;
};

struct dev {
	char id;
	int (*stat)(Chan *c, char *file, unsigned char *buf, int n);
	int (*walk)(Chan *c, char *name);
	int (*read)(Chan *c, void *buf, int n);
	int (*write)(Chan *c, void *buf, int n);
	int (*seek)(Chan *c, long off, int whence);
	int (*sync)(Chan *c, int what);
	Chan *(*clone)(Chan *c, Chan *nc);
	Chan *(*attach)(int id, int dev);
        Chan *(*mount)(Chan *c, char *spec);
};

struct attr {
	char *key;
	char *value;
};

extern int sameqid(Qid q1, Qid qid2);
extern Chan *namec(char *name, int mode);
extern Chan *clone(Chan *c, Chan *nc);
extern Chan *attach(int id, int dev);
extern Chan *newchan(unsigned char type);
extern void delchan(Chan *c);
extern int buf2chan(Chan *c,
                    void *dst, void *src,
                    int nbytes, long len);
extern void mkentry(Chan *c, Dir *dir,
                    char *name,
                    long length, Qid qid, unsigned mode);
extern void devlink(void);

extern Chan *devattach(int id, int dev);
extern int devseek(Chan *c, long off, int whence);
extern int devsync(Chan *c, int what);
extern Chan *devclone(Chan *c, Chan *nc);
extern int devgen(Chan *c,
                  Dirtab *tab, int ntab,
                  int n,
                  Dir *dir);
extern int devwalk(Chan *c,
                   char *name,
                   Dirtab *tab, int ntab,
                   Devgen *gen);
extern int dirread(Chan *c,
                   unsigned char *buf, int nbytes,
                   Dirtab *tab, int ntab,
                   Devgen *gen);
int
extern devstat(Chan *dirc, char *file,
               unsigned char *buf, int n,
               Dirtab *tab, int ntab,
               Devgen *gen);

extern Chan *deverrmount(Chan *c, char *spec);
extern int deverrwrite(Chan *c, void *buf, int n);
extern int deverrseek(Chan *c, long off, int whence);

extern Dev *devtab[];
