#include <os9/os9.h>

#include "../src/libc/syscall.h"
#include "dev.h"
#include "blk.h"

/*
 * A block file filled with zeros can be created with:
 * dd bs=512 count=2 if=/dev/zero of=blkfile
 */

void
dummyblkinit(Blk *dev, Attr *attr)
{
	static char filename[] = "blkfile";
	int fd;

	if ((fd = _open(filename, 0x2)) < 0)
		panic("blkinit");
	dev->data = alloc(sizeof(fd));
	*(int *)dev->data = fd;
}

int
dummyblkbread(Blk *dev, long blkno, void *buf)
{
	int fd;

	fd = *(int *) dev->data;
	_lseek(fd, blkno * BLKSIZ, 0);
	return _read(fd, buf, BLKSIZ);
}

int
dummyblkbwrite(Blk *dev, long blkno, void *buf)
{
	int fd;

	fd = *(int *) dev->data;
	_lseek(fd, blkno * BLKSIZ, 0);
	return _write(fd, buf, BLKSIZ);
}

Blkphy dummyblkphy = {
	.init = dummyblkinit,
	.bread  = dummyblkbread,
	.bwrite = dummyblkbwrite
};
