typedef struct uart Uart;
typedef struct uartphy Uartphy;

enum rs232sig {
	SIG_DCD,
	SIG_RXD,
	SIG_TXD,
	SIG_DTR,
	SIG_DSR,
	SIG_RTS,
	SIG_CTS,
	SIG_RI,
};

enum parity {
	OPARITY = 'o',
	EPARITY = 'e',
	NPARITY = 'n',
};

struct uartstat {
	/* TODO: add stats */
	int dummy;
};	

struct uart {
	long rate;
	int nbits;
	int nstop;
	int hang;
	int ctsflow;
	int parity;
	int fifo;
	int dtr;
	int rts;
	long clk;
	void *base;

	mutex_t m;
	Uartphy *phy;
};

struct uartphy {
	void (*init)(Uart *up, Attr *attr);
	int (*setbauds)(Uart *up, long rate);
	int (*signal)(Uart *up, int mask, int val);
	int (*read)(Uart *up, void *buf, int n);
	int (*write)(Uart *up, void *buf, int n);
	int (*flush)(Uart *uart);
	int (*setfifo)(Uart *uart, int size);
	int (*numbits)(Uart *uart, int nbits);
	int (*parity)(Uart *uart, int type);
	int (*bitstop)(Uart *up, int nstops);
	int (*obey)(Uart *uart, int type, int ena);

	int (*status)(Uart *up, struct uartstat *st);
};

extern void uartlink(Uartphy *phy, Attr *attr);
