#include <setjmp.h>
#include <stdlib.h>
#include <string.h>

#include <libk.h>
#include <os9/os9.h>

#include "hosted.h"
#include "../../libc/syscall.h"

noreturn void longjmp(jmp_buf env, int val);

Chan *console;
Mach mach;

int
getch(void)
{
	char ch;

	if (console) {
		devread(console, &ch, 1);
	} else {
		_read(0, &ch, 1);
	}

	return ch;
}

void
putch(int c)
{
	char ch = c;

	if (console) {
		devwrite(console, &ch, 1);
	} else {
		_write(1, &ch, 1);
	}
}

void
panic(const char *msg)
{
	kprint("panic %s\n", msg);
	longjmp(recover, 1);
}

static void
imach(void)
{
	if (setjmp(recover))
		exit(EXIT_FAILURE);
}

char *
getconf(char *name)
{
	static char constxt[] =
		"addin #t0/raw\n"
		"addout #t0/raw\n";

	return constxt;
}

int
main(int argc, char *argv[])
{
	imach();
	isys();

	return 0;
}
